package zuora.metabuilder;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.regex.Pattern;
import java.util.stream.Collectors;

import com.google.common.base.Strings;

import zuora.metabuilder.Meta.ColumnInfo;
import zuora.metabuilder.Meta.TableInfo;
import zuora.metabuilder.Utilities.Tuple;

public class SecondPassCompile {
	static boolean _debug = false;
	
	private static Set<String> getDBFields(Meta meta, String tableName) {
		Set<String> ret = new HashSet<>();
		TableInfo ti = meta.tableMap.get(tableName);
		if (ti != null) {
			ti.colMap.keySet().stream().forEach((x) -> {ret.add(x.toLowerCase());});
		}
		return ret;
	}

	public static Set<String> exclusions = new HashSet<>();
	static {
		for (String s : new String[] { "oid", "deleted", "version_optimized_lock"} )
			exclusions.add(s);
	}
	
	enum Operation {
		EQ,
		PREFIX,
		POSTFIX
	};
		
	public static void compile(Meta meta, Meta metaRef, File gvFile, String regex) throws IOException {
		Utilities.Debug();
		
		//Pass 1: do some counts
		long tablesWithoutPrimaryKeys = meta.tableMap
											.values()
											.stream()
											.filter((TableInfo ti)  -> { 
												if (ti.pkColumns.size() == 0 && !ti.isTableNameAutoGenerated) {
													Utilities.Debug();
													return true;
												} else 
													return false;
											})
											.collect(Collectors.counting());

		long columnsWithoutJavaClass  = meta.tableMap
											.values()
											.stream()
											.flatMap((TableInfo ti) -> ti
																		.colMap
																		.entrySet()
																		.stream()
																		.map((x) -> new Utilities.Tuple<>(ti, x)))
											.filter((x) -> {
												if ((Strings.isNullOrEmpty(x.b.getValue().javaClass) &&
													 Strings.isNullOrEmpty(x.b.getValue().colType)) &&
												    !x.a.isTableNameAutoGenerated) {
													System.out.printf("No JavaClass for [%s:%s] (%s):{%s}\n", 
															x.b.getValue().tableName, x.b.getValue().colName, x.a.javaClass, x.a.source);
													Utilities.Debug();
													return true;
												} else
													return false;
											})
											.collect(Collectors.counting());
				
		//Pass 1: Resolve the SQL Column Types for both Classes and Views
		List<Tuple<String, TableInfo>> itemList = new ArrayList<>();
		meta.tableMap.entrySet().forEach(x -> { itemList.add(new Tuple<>(x.getKey(), x.getValue())); });
		for (Map.Entry<String, List<TableInfo>> ve : meta.viewMap.entrySet()) {
			for (TableInfo vti : ve.getValue())
				itemList.add(new Tuple<String, TableInfo>(ve.getKey(), vti));
		}
		for (Tuple<String, TableInfo> me : itemList) {
			TableInfo ti = me.b;
			
			if (Diagnostics.trackClass(ti.javaClass, null))
				Utilities.Debug();

			for (Map.Entry<String, ColumnInfo> me2 : ti.colMap.entrySet()) {
				ColumnInfo ci = me2.getValue();
				ColumnInfo ciTarget = null;
				if (Strings.isNullOrEmpty(ci.colType) || !Utilities.IsValidHibernateType(ci.colType)) {
					TableInfo tiTarget = metaRef.tableMap.get(ti.tableName);
					if (tiTarget != null) {
						ciTarget = tiTarget.colMap.get(ci.colName);
					}
					ci.colType = null;
					Utilities.fillDBTypeFromColumnInfo(ti, ci, tiTarget, ciTarget, meta);
					Utilities.Debug();
				}
			}
		}
		
		//Pass 2: Loop over all tables and find differences
		int unresolvedFKs = 0, resolvedFKs = 0, tableCount = 0, mismatchTables = 0, mismatchColumns = 0;
		
		try (FileWriter fw = new FileWriter(gvFile)) {
			try (PrintWriter pw = new PrintWriter(fw)) {
				
				Set<String> tablesToPrint = new HashSet<>();
				
				// Loop over all tables. Resolving Foreign Keys
				for (Map.Entry<String, TableInfo> me : meta.tableMap.entrySet()) {
					tableCount++;
					
					TableInfo ti = me.getValue();

					if (Diagnostics.trackClass(ti.javaClass, null))
						Utilities.Debug();
					
					if (Pattern.matches(regex, ti.tableName.toUpperCase()))
						tablesToPrint.add(ti.tableName);
					
					if (metaRef != null) {
						
						// Compare Database with MetaRef
						Set<String> dbFields = getDBFields(metaRef, ti.tableName);
						if (dbFields.size() > 0) {
							Set<String> collectedFields = ti.colMap.keySet().stream().collect(Collectors.toSet());
							Set<String> intersection    = Utilities.compareSets(collectedFields, dbFields, exclusions);
							Set<String> missing = intersection
									.stream()
									.sorted()
									.filter((x) -> {
										if (x.endsWith("+"))
											return false;
										if (x.startsWith("field_"))
											return false;
										if (x.startsWith("date_"))
											return false;
										if (x.startsWith("datetime_"))
											return false;
										if (x.startsWith("timestamp_"))
											return false;
										return true;
										})
									.collect(Collectors.toSet());					
							if (missing.size() > 0) {						
								mismatchTables++;
								mismatchColumns += dbFields.size();
								
								if (Diagnostics.trackClass(ti.javaClass, null)) {
									System.out.printf("[%4d] Table:[%s], Class:[%s], Mismatch Columns:[(%d) %s] All Columns:[%s] Source: {%s}\n",
											tableCount,
											ti.tableName, 
											ti.javaClass, 
											missing.size(),
											missing.stream().sorted().collect(Collectors.joining(", ")),
											ti.colMap
												.values()
												.stream()
												.map(x->x.colName)
												.sorted()
												.collect(Collectors.joining(", ")),
											ti.source
											);
									System.out.printf("--------------------------------------------------------------------------------------------------------------------------------------------------------------\n");
								}
							}
						}
					}

					if (Diagnostics.trackClass(ti.javaClass, null))
						Utilities.Debug();

					// Resolve Foreign Keys
					for (Map.Entry<String, ColumnInfo> me2 : ti.colMap.entrySet()) {
						ColumnInfo ci = me2.getValue();
						if (ci.annotations != null && ci.annotations.containsKey(Meta.c_ManyOneAnnotationProperty)) {
							Map<String, Object> manyToOneProp = ci.annotations.get(Meta.c_ManyOneAnnotationProperty);
							if (manyToOneProp != null && manyToOneProp.size() > 0) {
								String clazz = (String)manyToOneProp.get(Meta.c_ManyOneClassProperty);
								if (clazz != null) {
									ArrayList<TableInfo> tisToTry = new ArrayList<>();
									if (meta.classMap.get(clazz) != null)
										tisToTry.add(meta.classMap.get(clazz));
									if (meta.viewMap.get(clazz) != null)
										tisToTry.addAll(meta.viewMap.get(clazz));
		
									boolean resolved = false;
									for (TableInfo tiTarget: tisToTry) {
										
										if (tiTarget.pkColumns.size() > 0) {
											
											StringBuilder fkLabel = new StringBuilder();
											boolean first = true;
											for (String targetColName : tiTarget.pkColumns) {
												if (first)
													first = false;
												else
													fkLabel.append(",");
												ColumnInfo ciTarget = tiTarget.colMap.get(targetColName);
												if (ciTarget != null) {
													fkLabel.append(ci.colName);		
													ci.fkTo = ciTarget;
												}
											}
											resolved = true;
											resolvedFKs++;
											
											boolean fWrite = Strings.isNullOrEmpty(regex);
											if (!fWrite) {
												fWrite = Pattern.matches(regex, ti.tableName.toUpperCase()) ||
														 Pattern.matches(regex, tiTarget.tableName.toUpperCase());
											}
											
											if (fWrite) {
												tablesToPrint.add(ti.tableName);
												tablesToPrint.add(tiTarget.tableName);
											}
											break;
										}
									}
									if (!resolved) {
										Utilities.Debug();
										unresolvedFKs++;
									}
								} else {
									Utilities.Debug();
								}
							}
						}
					}
				}
				
				System.out.println("----------------------------------------");
				for (Map.Entry<String, TableInfo> me : meta.tableMap.entrySet()) {
					if (me.getKey().toUpperCase().contains("ORDER")) {
						Utilities.Debug();
						System.out.printf("[%s: %s]\n", me.getKey(), me.getValue().tableName);
					}
				}
				System.out.println("----------------------------------------");
								
				// Now do all the printing
				pw.printf("digraph {\n");
				pw.printf("rankdir=LR;\n");
				pw.printf("node [ fontname=Arial, fontcolor=blue, fontsize=8 shape=record ];\n");
				pw.printf("edge [ fontname=Helvetica, fontcolor=red, fontsize=8 ];\n");
				pw.printf("\n");
								
				// First loop over all the tables and print the table info
				for (Map.Entry<String, TableInfo> me : meta.tableMap.entrySet()) {
					TableInfo ti = me.getValue();
					if (tablesToPrint.contains(ti.tableName)) {
						StringBuilder sb = new StringBuilder();
						for (ColumnInfo ci : ti.colMap.values()) {
							if (ci.isPrimaryKey || ci.fkTo != null) {
								sb.append("<TR>"); 
								sb.append("<TD>");
								if (ci.isPrimaryKey) {
									sb.append("<FONT COLOR=\"red\" POINT-SIZE=\"10.0\">");
									sb.append(ci.colName);
									sb.append("</FONT>");
									sb.append(" (PK)");
								} else 
									sb.append(ci.colName);
								sb.append("</TD>");
								sb.append("</TR>"); 
								sb.append("\n"); 
							}
						}
						boolean tableBorder = Pattern.matches(regex, ti.tableName.toUpperCase());
						if (tableBorder)
							Utilities.Debug();
						pw.printf("\t%s [ label=<<TABLE BORDER=\"%s\" CELLBORDER=\"0\" CELLSPACING=\"0\"><TR><TD COLOR=\"red\"><FONT COLOR=\"red\" POINT-SIZE=\"10.0\"><B>%s</B></FONT></TD></TR>\n%s</TABLE>> ]; \n", 
								ti.tableName, 
								tableBorder ? "1" : "0", 
								ti.tableName, 
								sb.toString());
					}
				}
				pw.printf("\n");

				// Then loop over all qualifying columns
				for (Map.Entry<String, TableInfo> me : meta.tableMap.entrySet()) {
					TableInfo ti = me.getValue();
					if (tablesToPrint.contains(ti.tableName)) {
						for (ColumnInfo ci : ti.colMap.values()) {
							if (ci.fkTo != null && tablesToPrint.contains(ci.fkTo.tableName)) {
								pw.printf("\t%s -> %s [label = \"[%s-%s]\" dir = both arrowtail = diamond];\n",
								ti.tableName, ci.fkTo.tableName, ci.colName, ci.fkTo.colName);
							}
						}
					}
				}

				pw.printf("}\n");
			}
		}
		
		//Diagnostic printing
		for (Map.Entry<String, TableInfo> me : meta.tableMap.entrySet()) {
			TableInfo ti = me.getValue();
			if (Diagnostics.trackClass(ti.javaClass, null))
				System.out.println(ti);
		}
		
		//Pass 3: Report statistics
		System.out.printf("--------------------------------------------------------------------------------------------------------------------------------------------------------------\n");
		System.out.printf("(Tables: %d), (Classes: %d), (Views: %d), (No PK Tables: %d), (Classless Cols: %d), "
					    + "(Resolved FKs: %d), (Unresolved FKs: %d), (MismatchTables: %d), (MismatchColumns: %d)\n",
				meta.tableMap.size(),
				meta.classMap.size(),
				meta.viewMap.size(),
				tablesWithoutPrimaryKeys, 
				columnsWithoutJavaClass,
				resolvedFKs,
				unresolvedFKs,
				mismatchTables,
				mismatchColumns);
		System.out.printf("--------------------------------------------------------------------------------------------------------------------------------------------------------------\n");
	}
	
	public static void mergeMetas(Meta toMeta, Meta fromMeta) {
		
		for (Map.Entry<String, TableInfo> me : toMeta.tableMap.entrySet()) {
			TableInfo tiTo = me.getValue();
			TableInfo tiFrom = fromMeta.tableMap.get(tiTo.tableName);
			if (tiFrom != null) {
				tiTo.state = Meta.State.FoundInDB;
				
				Set<String> colsSeenSoFar = new HashSet<>();
				for (Map.Entry<String, ColumnInfo> ciToMe : tiTo.colMap.entrySet()) {
					ColumnInfo ciTo = ciToMe.getValue();
					ColumnInfo ciFrom = tiFrom.colMap.get(ciToMe.getKey());
					if (ciFrom != null) {
						colsSeenSoFar.add(ciToMe.getKey());
						ciTo.colNameInDB = ciFrom.colName;
						ciTo.state = Meta.State.FoundInDB;
					}
				}
				
				Set<String> allColumnsInDB = new HashSet<>(tiFrom.colMap.keySet());
				allColumnsInDB.removeAll(colsSeenSoFar);
				
				// allColumnsInDB now contains columns in fromMeta that are not in toMeta
				for (String colInFromOnly : allColumnsInDB) {
					ColumnInfo ciLeft = tiFrom.colMap.get(colInFromOnly);
					tiTo.colMap.put(colInFromOnly, ciLeft);
					ciLeft.colNameInDB = ciLeft.colName;
				}
			}
		}		
	}
}
